import{s as je,n as Ce,o as Me}from"../chunks/scheduler.c57aa7ef.js";import{S as Ee,i as Pe,g as i,s as n,r as _,A as He,h as a,f as t,c as o,j as x,u as v,x as w,k as $,y as m,a as s,v as T,d as b,t as y,w as k}from"../chunks/index.c50cb18e.js";import{D as V}from"../chunks/Docstring.66f18243.js";import{H as Se,E as Ie}from"../chunks/EditOnGithub.958a8a49.js";function Ve(ve){let l,B,U,J,D,K,L,$e='PEFT provides several internal utilities for <a href="../developer_guides/model_merging">merging LoRA adapters</a> with the TIES and DARE methods.',N,d,j,pe,q,Te="Prune the values of task tensors based on the <code>method</code>.",Q,c,C,ue,A,be="Get the mask of the majority sign across the task tensors. Task tensors are stacked on dimension 0.",X,p,M,ge,R,ye="Merge the task tensors using disjoint merge.",Y,u,E,he,F,ke="Merge the task tensors using <code>task arithmetic</code>.",Z,g,P,fe,G,we="Merge the task tensors using <code>ties</code>.",ee,h,H,_e,z,De="Merge the task tensors using <code>dare linear</code>.",te,f,S,xe,O,Le="Merge the task tensors using <code>dare ties</code>.",re,I,se,W,ne;return D=new Se({props:{title:"Model merge",local:"peft.utils.merge_utils.prune",headingTag:"h1"}}),j=new V({props:{name:"peft.utils.merge_utils.prune",anchor:"peft.utils.merge_utils.prune",parameters:[{name:"tensor",val:": Tensor"},{name:"density",val:": float"},{name:"method",val:": Literal"},{name:"rescale",val:": bool = False"}],parametersDescription:[{anchor:"peft.utils.merge_utils.prune.tensor",description:"<strong>tensor</strong> (<code>torch.Tensor</code>) &#x2014;The tensor to prune.",name:"tensor"},{anchor:"peft.utils.merge_utils.prune.density",description:"<strong>density</strong> (<code>float</code>) &#x2014;The fraction of values to preserve. Should be in [0,1].",name:"density"},{anchor:"peft.utils.merge_utils.prune.method",description:"<strong>method</strong> (<code>str</code>) &#x2014;The method to use to prune. Should be one of [&#x201C;magnitude&#x201D;, &#x201C;random&#x201D;].",name:"method"},{anchor:"peft.utils.merge_utils.prune.rescale",description:"<strong>rescale</strong> (<code>bool</code>) &#x2014;Whether to rescale the result to preserve the expected value of the original tensor.",name:"rescale"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/utils/merge_utils.py#L75",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The pruned tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),C=new V({props:{name:"peft.utils.merge_utils.calculate_majority_sign_mask",anchor:"peft.utils.merge_utils.calculate_majority_sign_mask",parameters:[{name:"tensor",val:": Tensor"},{name:"method",val:": Literal = 'total'"}],parametersDescription:[{anchor:"peft.utils.merge_utils.calculate_majority_sign_mask.tensor",description:"<strong>tensor</strong> (<code>torch.Tensor</code>) &#x2014;The tensor to get the mask from.",name:"tensor"},{anchor:"peft.utils.merge_utils.calculate_majority_sign_mask.method",description:"<strong>method</strong> (<code>str</code>) &#x2014;The method to use to get the mask. Should be one of [&#x201C;total&#x201D;, &#x201C;frequency&#x201D;].",name:"method"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/utils/merge_utils.py#L103",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The majority sign mask.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),M=new V({props:{name:"peft.utils.merge_utils.disjoint_merge",anchor:"peft.utils.merge_utils.disjoint_merge",parameters:[{name:"task_tensors",val:": Tensor"},{name:"majority_sign_mask",val:": Tensor"}],parametersDescription:[{anchor:"peft.utils.merge_utils.disjoint_merge.task_tensors",description:"<strong>task_tensors</strong> (<code>torch.Tensor</code>) &#x2014;The task tensors to merge.",name:"task_tensors"},{anchor:"peft.utils.merge_utils.disjoint_merge.majority_sign_mask",description:"<strong>majority_sign_mask</strong> (<code>torch.Tensor</code>) &#x2014;The mask of the majority sign across the task tensors.",name:"majority_sign_mask"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/utils/merge_utils.py#L128",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The merged tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),E=new V({props:{name:"peft.utils.merge_utils.task_arithmetic",anchor:"peft.utils.merge_utils.task_arithmetic",parameters:[{name:"task_tensors",val:": List"},{name:"weights",val:": Tensor"}],parametersDescription:[{anchor:"peft.utils.merge_utils.task_arithmetic.weights",description:"<strong>weights</strong> (<code>torch.Tensor</code>) &#x2014;The weights of the task tensors.",name:"weights"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/utils/merge_utils.py#L144",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The merged tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),P=new V({props:{name:"peft.utils.merge_utils.ties",anchor:"peft.utils.merge_utils.ties",parameters:[{name:"task_tensors",val:": List"},{name:"weights",val:": Tensor"},{name:"density",val:": float"},{name:"majority_sign_method",val:": Literal = 'total'"}],parametersDescription:[{anchor:"peft.utils.merge_utils.ties.weights",description:"<strong>weights</strong> (<code>torch.Tensor</code>) &#x2014;The weights of the task tensors.",name:"weights"},{anchor:"peft.utils.merge_utils.ties.density",description:"<strong>density</strong> (<code>float</code>) &#x2014;The fraction of values to preserve. Should be in [0,1].",name:"density"},{anchor:"peft.utils.merge_utils.ties.majority_sign_method",description:`<strong>majority_sign_method</strong> (<code>str</code>) &#x2014;
The method to use to get the majority sign mask. Should be one of [&#x201C;total&#x201D;, &#x201C;frequency&#x201D;].`,name:"majority_sign_method"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/utils/merge_utils.py#L185",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The merged tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),H=new V({props:{name:"peft.utils.merge_utils.dare_linear",anchor:"peft.utils.merge_utils.dare_linear",parameters:[{name:"task_tensors",val:": List"},{name:"weights",val:": Tensor"},{name:"density",val:": float"}],parametersDescription:[{anchor:"peft.utils.merge_utils.dare_linear.weights",description:"<strong>weights</strong> (<code>torch.Tensor</code>) &#x2014;The weights of the task tensors.",name:"weights"},{anchor:"peft.utils.merge_utils.dare_linear.density",description:"<strong>density</strong> (<code>float</code>) &#x2014;The fraction of values to preserve. Should be in [0,1].",name:"density"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/utils/merge_utils.py#L217",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The merged tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),S=new V({props:{name:"peft.utils.merge_utils.dare_ties",anchor:"peft.utils.merge_utils.dare_ties",parameters:[{name:"task_tensors",val:": List"},{name:"weights",val:": Tensor"},{name:"density",val:": float"},{name:"majority_sign_method",val:": Literal = 'total'"}],parametersDescription:[{anchor:"peft.utils.merge_utils.dare_ties.weights",description:"<strong>weights</strong> (<code>torch.Tensor</code>) &#x2014;The weights of the task tensors.",name:"weights"},{anchor:"peft.utils.merge_utils.dare_ties.density",description:"<strong>density</strong> (<code>float</code>) &#x2014;The fraction of values to preserve. Should be in [0,1].",name:"density"},{anchor:"peft.utils.merge_utils.dare_ties.majority_sign_method",description:`<strong>majority_sign_method</strong> (<code>str</code>) &#x2014;
The method to use to get the majority sign mask. Should be one of [&#x201C;total&#x201D;, &#x201C;frequency&#x201D;].`,name:"majority_sign_method"}],source:"https://github.com/huggingface/peft/blob/main/src/peft/utils/merge_utils.py#L239",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The merged tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),I=new Ie({props:{source:"https://github.com/huggingface/peft/blob/main/docs/source/package_reference/merge_utils.md"}}),{c(){l=i("meta"),B=n(),U=i("p"),J=n(),_(D.$$.fragment),K=n(),L=i("p"),L.innerHTML=$e,N=n(),d=i("div"),_(j.$$.fragment),pe=n(),q=i("p"),q.innerHTML=Te,Q=n(),c=i("div"),_(C.$$.fragment),ue=n(),A=i("p"),A.textContent=be,X=n(),p=i("div"),_(M.$$.fragment),ge=n(),R=i("p"),R.textContent=ye,Y=n(),u=i("div"),_(E.$$.fragment),he=n(),F=i("p"),F.innerHTML=ke,Z=n(),g=i("div"),_(P.$$.fragment),fe=n(),G=i("p"),G.innerHTML=we,ee=n(),h=i("div"),_(H.$$.fragment),_e=n(),z=i("p"),z.innerHTML=De,te=n(),f=i("div"),_(S.$$.fragment),xe=n(),O=i("p"),O.innerHTML=Le,re=n(),_(I.$$.fragment),se=n(),W=i("p"),this.h()},l(e){const r=He("svelte-u9bgzb",document.head);l=a(r,"META",{name:!0,content:!0}),r.forEach(t),B=o(e),U=a(e,"P",{}),x(U).forEach(t),J=o(e),v(D.$$.fragment,e),K=o(e),L=a(e,"P",{"data-svelte-h":!0}),w(L)!=="svelte-bbuf1j"&&(L.innerHTML=$e),N=o(e),d=a(e,"DIV",{class:!0});var oe=x(d);v(j.$$.fragment,oe),pe=o(oe),q=a(oe,"P",{"data-svelte-h":!0}),w(q)!=="svelte-1y1urne"&&(q.innerHTML=Te),oe.forEach(t),Q=o(e),c=a(e,"DIV",{class:!0});var ie=x(c);v(C.$$.fragment,ie),ue=o(ie),A=a(ie,"P",{"data-svelte-h":!0}),w(A)!=="svelte-1fmtw9r"&&(A.textContent=be),ie.forEach(t),X=o(e),p=a(e,"DIV",{class:!0});var ae=x(p);v(M.$$.fragment,ae),ge=o(ae),R=a(ae,"P",{"data-svelte-h":!0}),w(R)!=="svelte-1yr0ip4"&&(R.textContent=ye),ae.forEach(t),Y=o(e),u=a(e,"DIV",{class:!0});var me=x(u);v(E.$$.fragment,me),he=o(me),F=a(me,"P",{"data-svelte-h":!0}),w(F)!=="svelte-8ih8a2"&&(F.innerHTML=ke),me.forEach(t),Z=o(e),g=a(e,"DIV",{class:!0});var le=x(g);v(P.$$.fragment,le),fe=o(le),G=a(le,"P",{"data-svelte-h":!0}),w(G)!=="svelte-1d45n1k"&&(G.innerHTML=we),le.forEach(t),ee=o(e),h=a(e,"DIV",{class:!0});var de=x(h);v(H.$$.fragment,de),_e=o(de),z=a(de,"P",{"data-svelte-h":!0}),w(z)!=="svelte-1ox69n2"&&(z.innerHTML=De),de.forEach(t),te=o(e),f=a(e,"DIV",{class:!0});var ce=x(f);v(S.$$.fragment,ce),xe=o(ce),O=a(ce,"P",{"data-svelte-h":!0}),w(O)!=="svelte-xv7fyw"&&(O.innerHTML=Le),ce.forEach(t),re=o(e),v(I.$$.fragment,e),se=o(e),W=a(e,"P",{}),x(W).forEach(t),this.h()},h(){$(l,"name","hf:doc:metadata"),$(l,"content",qe),$(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(c,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(p,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,r){m(document.head,l),s(e,B,r),s(e,U,r),s(e,J,r),T(D,e,r),s(e,K,r),s(e,L,r),s(e,N,r),s(e,d,r),T(j,d,null),m(d,pe),m(d,q),s(e,Q,r),s(e,c,r),T(C,c,null),m(c,ue),m(c,A),s(e,X,r),s(e,p,r),T(M,p,null),m(p,ge),m(p,R),s(e,Y,r),s(e,u,r),T(E,u,null),m(u,he),m(u,F),s(e,Z,r),s(e,g,r),T(P,g,null),m(g,fe),m(g,G),s(e,ee,r),s(e,h,r),T(H,h,null),m(h,_e),m(h,z),s(e,te,r),s(e,f,r),T(S,f,null),m(f,xe),m(f,O),s(e,re,r),T(I,e,r),s(e,se,r),s(e,W,r),ne=!0},p:Ce,i(e){ne||(b(D.$$.fragment,e),b(j.$$.fragment,e),b(C.$$.fragment,e),b(M.$$.fragment,e),b(E.$$.fragment,e),b(P.$$.fragment,e),b(H.$$.fragment,e),b(S.$$.fragment,e),b(I.$$.fragment,e),ne=!0)},o(e){y(D.$$.fragment,e),y(j.$$.fragment,e),y(C.$$.fragment,e),y(M.$$.fragment,e),y(E.$$.fragment,e),y(P.$$.fragment,e),y(H.$$.fragment,e),y(S.$$.fragment,e),y(I.$$.fragment,e),ne=!1},d(e){e&&(t(B),t(U),t(J),t(K),t(L),t(N),t(d),t(Q),t(c),t(X),t(p),t(Y),t(u),t(Z),t(g),t(ee),t(h),t(te),t(f),t(re),t(se),t(W)),t(l),k(D,e),k(j),k(C),k(M),k(E),k(P),k(H),k(S),k(I,e)}}}const qe='{"title":"Model merge","local":"peft.utils.merge_utils.prune","sections":[],"depth":1}';function Ae(ve){return Me(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Oe extends Ee{constructor(l){super(),Pe(this,l,Ae,Ve,je,{})}}export{Oe as component};
